<?php
if (!defined('ABSPATH')) {
    die(__("Can't load this file directly", "woo-import-export"));
}
global $wpie_init, $wpie_product, $wpie_product_category, $wpie_scheduled, $wpie_order;

$order_status = $wpie_order->get_woo_order_status();

$product_category_list = $wpie_product_category->wpie_get_product_category();

$get_schedules_list = wp_get_schedules();

$product_list = $wpie_product->wpie_get_all_products();

$order_ids = $wpie_order->get_order_list();

$order_fields = $wpie_order->get_updated_order_fields();

$order_scheduled_export_list = $wpie_scheduled->get_order_scheduled_data();

$order_scheduled_import_list = $wpie_scheduled->get_order_import_scheduled_data();

$log_list = $wpie_order->wpie_get_order_export_log();

$import_log_list = $wpie_order->wpie_get_order_import_log();

$total_orders = count($order_ids) < 2000 ? count($order_ids) : "2000+";
?>
<div class="wpie-process-notification">
    <div class="wpie-process-percentage">0</div>
    <div class="wpie-process-notification-content">% <?php esc_html_e('Please Wait...', 'woo-import-export'); ?></div>
</div>
<div class="wpie_success_msg" wpie_wait_msg="<?php esc_html_e('Please Wait...', 'woo-import-export') ?>"><?php esc_html_e('Please Wait...', 'woo-import-export') ?></div>
<div class="wpie-page-wrapper">
    <div class="container-fluid offset-10">
        <div class="col-lg-3 col-md-4 col-sm-6 col-xs-12">
            <div class="wpie-page-section-header wpie-red-section wpie-page-active-section" wpie-container="wpie-filter-wrapper">
                <div class="wpie-header-title-count"><?php esc_html_e('Export', 'woo-import-export'); ?></div>
                <div class="wpie-header-title-content"><?php esc_html_e('Orders', 'woo-import-export'); ?></div>
                <div class="wpie-header-title-subtitle"><?php
                    echo esc_html($total_orders) . " ";
                    esc_html_e('Available orders in store.', 'woo-import-export');
                    ?>
                </div>
                <div class="wpie-header-title-image wpie-export-image"></div>
            </div>
        </div>
        <div class="col-lg-3 col-md-4 col-sm-6 col-xs-12">
            <div class="wpie-page-section-header wpie-green-section" wpie-container="wpie-import-wrapper">
                <div class="wpie-header-title-count"><?php esc_html_e('Import', 'woo-import-export'); ?></div>
                <div class="wpie-header-title-content"><?php esc_html_e('Orders', 'woo-import-export'); ?></div>
                <div class="wpie-header-title-subtitle"><?php esc_html_e('Import unlimited orders.', 'woo-import-export'); ?></div>
                <div class="wpie-header-title-image wpie-import-image"></div>
            </div>
        </div>
        <div class="col-lg-3 col-md-4 col-sm-6 col-xs-12">
            <div class="wpie-page-section-header wpie-aqua-section" wpie-container="wpie-scheduled-wrapper">
                <div class="wpie-header-title-count"><?php esc_html_e('Schedule', 'woo-import-export'); ?></div>
                <div class="wpie-header-title-content"><?php esc_html_e('Management', 'woo-import-export'); ?></div>
                <div class="wpie-header-title-subtitle"><?php esc_html_e('schedule import export.', 'woo-import-export'); ?></div>
                <div class="wpie-header-title-image wpie-schedule-image"></div>
            </div>
        </div>
        <div class="col-lg-3 col-md-4 col-sm-6 col-xs-12">
            <div class="wpie-page-section-header wpie-color-section1" wpie-container="wpie-advanced-wrapper"> 
                <div class="wpie-header-title-count"><?php esc_html_e('Advance', 'woo-import-export'); ?></div>
                <div class="wpie-header-title-content"><?php esc_html_e('Orders', 'woo-import-export'); ?></div>
                <div class="wpie-header-title-subtitle"><?php esc_html_e('Configure import export', 'woo-import-export'); ?></div>
                <div class="wpie-header-title-image wpie-settings-image"></div>
            </div>
        </div>
    </div>
    <div class="container-fluid offset-10 wpie-filter-wrapper  wpie-main-frm-wrapper  wpie-page-active-section-data">
        <form class="wpie-product-csv-download" method="post">
            <input type="hidden" value="" class="wpie-product-csv-file-name" name="wpie-product-csv-file-name">
        </form>
        <form method="post" class="wpie-order-export-frm wpie-general-frm">
            <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
                <div class="wpie-filter-inner-wrapper">
                    <div class="wpie-filter-title-text-wrapper">
                        <div class="wpie-filter-title-text"><?php esc_html_e('Filter By Order Status', 'woo-import-export'); ?></div>
                        <div class="wpie-filter-title-text-sub-title">(<?php
                            esc_html_e('Total Status', 'woo-import-export');
                            echo esc_html(" : " . $total_orders);
                            ?> )</div>
                    </div>
                    <div class="wpie-filter-input-wrapper">
                        <select class="wpie-select-chosen wpie_export_field_select_element" name="wpie_order_status[]" multiple="multiple" data-placeholder="<?php esc_attr_e('Select Order Status', 'woo-import-export'); ?>">
                            <?php
                            if (!empty($order_status)) {

                                if (function_exists('wc_get_order_statuses')) {

                                    global $wpdb;

                                    foreach ($order_status as $key => $value) {

                                        $total_query = ' SELECT COUNT(*) as nb from ' . $wpdb->prefix . 'posts where post_status="' . $key . '" and post_type="shop_order" ';

                                        $total = $wpdb->get_var($total_query);
                                        ?>
                                        <option value="<?php echo esc_attr($key); ?>" ><?php echo esc_html($value . " ( " . $total . " )"); ?></option>

                                        <?php
                                        unset($total_query, $total);
                                    }
                                } else {

                                    foreach ($order_status as $status) {
                                        ?>
                                        <option value="<?php echo esc_attr(isset($status->term_id) ? $status->term_id : ""); ?>" ><?php esc_html(__($status->name, 'woocommerce') . " ( " . $status->count . " )"); ?></option>				
                                        <?php
                                    }
                                }
                            }
                            ?>
                        </select>
                    </div>
                    <div class="wpie-filter-input-hint-wrapper">
                        <div class="wpie-filter-input-hint"><?php esc_html_e('Default : All Status', 'woo-import-export'); ?></div>
                    </div>
                </div>
            </div>
            <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
                <div class="wpie-filter-inner-wrapper">
                    <div class="wpie-filter-title-text-wrapper">
                        <div class="wpie-filter-title-text"><?php esc_html_e('Filter By Product Category', 'woo-import-export'); ?></div>
                        <div class="wpie-filter-title-text-sub-title">(<?php
                            esc_html_e('Total Categories', 'woo-import-export');
                            echo esc_html(" : " . count($product_category_list));
                            ?> )</div>
                    </div>
                    <div class="wpie-filter-input-wrapper">
                        <select class="wpie-select-chosen"  name="wpie_product_category[]" multiple="multiple" data-placeholder="<?php esc_attr_e('Select Product Categories', 'woo-import-export'); ?>">
                            <?php
                            foreach ($product_category_list as $wpie_category) {
                                echo '<option value="' . esc_attr($wpie_category->term_id) . '">#' . esc_html($wpie_category->term_id . ' ' . $wpie_category->name) . '</option>';
                            }
                            ?>
                        </select>
                    </div>
                    <div class="wpie-filter-input-hint-wrapper">
                        <div class="wpie-filter-input-hint"><?php esc_html_e('Default : All Categories', 'woo-import-export'); ?></div>
                    </div>
                </div>
            </div>
            <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
                <div class="wpie-filter-inner-wrapper">
                    <div class="wpie-filter-title-text-wrapper">
                        <div class="wpie-filter-title-text"><?php esc_html_e('Filter By Product ID / Name', 'woo-import-export'); ?></div>
                        <div class="wpie-filter-title-text-sub-title">(<?php
                            esc_html_e('Total Products', 'woo-import-export');
                            echo esc_html(" : " . count($product_list));
                            ?> )</div>
                    </div>
                    <div class="wpie-filter-input-wrapper">
                        <select class="wpie-select-chosen wpie_export_field_select_element" name="wpie_product_ids[]" multiple="multiple" data-placeholder="<?php esc_attr_e('Select Product', 'woo-import-export'); ?>">
                            <?php if (!empty($product_list)) { ?>
                                <?php foreach ($product_list as $product_data) { ?>
                                    <option value="<?php echo esc_attr($product_data->ID); ?>"><?php echo esc_html('#' . $product_data->ID . ' ' . $product_data->post_title); ?></option>
                                <?php } ?>
                            <?php } ?>
                        </select>
                    </div>
                    <div class="wpie-filter-input-hint-wrapper">
                        <div class="wpie-filter-input-hint"><?php esc_html_e('Default : All Products.', 'woo-import-export'); ?></div>
                    </div>
                </div>
            </div>
            <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
                <div class="wpie-filter-inner-wrapper">
                    <div class="wpie-filter-title-text-wrapper">
                        <div class="wpie-filter-title-text"><?php esc_html_e('Filter By Order Id', 'woo-import-export'); ?></div>
                        <div class="wpie-filter-title-text-sub-title">(<?php
                            esc_html_e('Total Order', 'woo-import-export');
                            echo esc_html(" : " . $total_orders);
                            ?> )</div>
                    </div>
                    <div class="wpie-filter-input-wrapper">
                        <select class="wpie-select-chosen wpie_export_field_select_element" name="wpie_order_ids[]" multiple="multiple" data-placeholder="<?php esc_attr_e('Select Order ID', 'woo-import-export'); ?>">
                            <?php if (!empty($order_ids)) { ?>
                                <?php foreach ($order_ids as $order_data) { ?>
                                    <option value="<?php echo esc_attr($order_data); ?>"><?php echo esc_html("#" . $order_data); ?></option>
                                <?php } ?>
                            <?php } ?>
                        </select>
                    </div>
                    <div class="wpie-filter-input-hint-wrapper">
                        <div class="wpie-filter-input-hint"><?php esc_html_e('Default : All Order ID.', 'woo-import-export'); ?></div>
                    </div>
                </div>
            </div>
            <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
                <div class="wpie-filter-inner-wrapper">
                    <div class="wpie-filter-title-text-wrapper">
                        <div class="wpie-filter-title-text"><?php esc_html_e('Filter By Date', 'woo-import-export'); ?></div>
                        <div class="wpie-filter-title-text-sub-title"></div>
                    </div>
                    <div class="wpie-filter-input-wrapper">
                        <div class="input-daterange input-group wpie-datepicker" >
                            <input type="text" class="input-sm form-control wpie-filter-date-input" name="wpie_start_date" placeholder="<?php esc_attr_e('Start Date', 'woo-import-export'); ?>" />
                            <span class="input-group-addon wpie-filter-date-to-label"><?php esc_html_e('To', 'woo-import-export'); ?></span>
                            <input type="text" class="input-sm form-control wpie-filter-date-input" name="wpie_end_date" placeholder="<?php esc_attr_e('End Date', 'woo-import-export'); ?>"/>
                        </div>
                    </div>
                    <div class="wpie-filter-input-hint-wrapper">
                        <div class="wpie-filter-input-hint"><?php esc_html_e('Date Format', 'woo-import-export'); ?> : mm-dd-yyyy</div>
                    </div>
                </div>
            </div>
            <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
                <div class="wpie-filter-inner-wrapper">
                    <div class="wpie-filter-title-text-wrapper">
                        <div class="wpie-filter-title-text"><?php esc_html_e('CSV Field Separator', 'woo-import-export'); ?></div>
                    </div>
                    <div class="wpie-filter-input-wrapper">
                        <input type="text" name="wpie_export_separator" class="wpie-filter-input wpie_export_separator" placeholder="<?php esc_attr_e('Enter Field Separator', 'woo-import-export'); ?>" value=","/>
                    </div>
                    <div class="wpie-filter-input-hint-wrapper">
                        <div class="wpie-filter-input-hint"><?php esc_html_e('Default : comma ( , )', 'woo-import-export'); ?></div>
                    </div>
                </div>
            </div>
            <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
                <div class="wpie-filter-inner-wrapper">
                    <div class="wpie-filter-title-text-wrapper">
                        <div class="wpie-filter-title-text"><?php esc_html_e('Records Per iteration', 'woo-import-export'); ?></div>
                    </div>
                    <div class="wpie-filter-input-wrapper">
                        <input type="text" name="wpie_export_records_per_iteration" class="wpie-filter-input wpie_export_records_per_iteration" placeholder="<?php esc_attr_e('Enter Records Per iteration', 'woo-import-export'); ?>" value="20"/>
                    </div>
                    <div class="wpie-filter-input-hint-wrapper">
                        <div class="wpie-filter-input-hint"><?php esc_html_e('Default : 20 Records', 'woo-import-export'); ?></div>
                    </div>
                </div>
            </div>
            <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
                <div class="wpie-filter-inner-wrapper">
                    <div class="wpie-filter-title-text-wrapper">
                        <div class="wpie-filter-title-text"><?php esc_html_e('Custom Filename', 'woo-import-export'); ?></div>
                    </div>
                    <div class="wpie-filter-input-wrapper">
                        <input type="text" name="wpie_export_custom_filename" class="wpie-filter-input wpie_export_custom_filename" placeholder="<?php esc_attr_e('Enter Custom Filename', 'woo-import-export'); ?>" value=""/>
                    </div>
                    <div class="wpie-filter-input-hint-wrapper">
                        <div class="wpie-filter-input-hint"><?php esc_html_e('Default : auto generated', 'woo-import-export'); ?></div>
                    </div>
                </div>
            </div>
            <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
                <div class="wpie-filter-inner-wrapper">
                    <div class="wpie-filter-title-text-wrapper">
                        <div class="wpie-filter-title-text"><?php esc_html_e('Scheduled Export', 'woo-import-export'); ?></div>
                        <div class="wpie-filter-title-text-sub-title"></div>
                    </div>
                    <div class="wpie-filter-input-wrapper">
                        <input type="checkbox" id="wpie-product-scheduled-export" class="wpie-filter-input-check wpie-scheduled-export-check-data" name="wpie_product_scheduled_export" placeholder="<?php esc_attr_e('Enter Offset Records', 'woo-import-export'); ?>"/>
                        <label for="wpie-product-scheduled-export" class="wpie-product-scheduled-export-label"><?php esc_html_e('Scheduled Export', 'woo-import-export'); ?></label>
                        <div class="wpie-scheduled-export-wrapper">
                            <div class="wpie-scheduled-export-outer-details">
                                <div class="wpie-scheduled-export-inner">
                                    <div class="wpie-scheduled-export-data-label"><?php esc_html_e('Export Interval', 'woo-import-export'); ?></div>
                                    <div class="wpie-scheduled-export-data-element-wrapper">
                                        <select class="wpie-export-field-select-element wpie-select-chosen" data-placeholder="<?php esc_attr_e('Select Interval', 'woo-import-export'); ?>" name="wpie_export_interval">
                                            <?php if (!empty($get_schedules_list)) { ?>
                                                <?php foreach ($get_schedules_list as $key => $value) { ?>
                                                    <option value="<?php echo esc_attr($key); ?>"><?php echo esc_html($value['display']); ?></option>
                                                <?php } ?>
                                            <?php } ?>
                                        </select>
                                    </div>
                                </div>
                                <div class="wpie-scheduled-export-inner">
                                    <div class="wpie-scheduled-export-data-label"><?php esc_html_e('Export Interval Time', 'woo-import-export'); ?></div>
                                    <div class="wpie-scheduled-export-data-element-wrapper">
                                        <input class="wpie-filter-input wpie-scheduled-export-time" type="text" placeholder="<?php esc_attr_e('Enter Time for export', 'woo-import-export'); ?>" name="wpie_scheduled_export_time">
                                        <div class="wpie-filter-input-hint"><?php esc_html_e('Value : 00:00:01 to 23:59:59, Default : Current time', 'woo-import-export'); ?></div>
                                    </div>
                                </div>
                                <div class="wpie-scheduled-export-inner">
                                    <div class="wpie-scheduled-export-data-label"><?php esc_html_e('Send E-mail', 'woo-import-export'); ?></div>
                                    <div class="wpie-scheduled-export-data-element-wrapper">
                                        <input type="checkbox" class="wpie-filter-input-check wpie-scheduled-send-email" id="wpie-scheduled-send-email" name="wpie_product_scheduled_send_email" value="1"/>
                                        <label for="wpie-scheduled-send-email" class="wpie-product-scheduled-export-label"><?php esc_html_e('Send E-mail with attachment', 'woo-import-export'); ?></label>
                                    </div>
                                </div>
                            </div>
                            <div class="wpie-scheduled-export-email-details">
                                <div class="wpie-scheduled-export-inner">
                                    <div class="wpie-scheduled-export-data-label"><?php esc_html_e('Enter Email Recipient(s)', 'woo-import-export'); ?></div>
                                    <div class="wpie-scheduled-export-data-element-wrapper">
                                        <input class="wpie-filter-input wpie-scheduled-export-email-recipients" type="text" placeholder="<?php esc_attr_e('Enter Email Recipient(s)', 'woo-import-export'); ?>" name="wpie_scheduled_export_email_recipients">
                                        <div class="wpie-filter-input-hint">Ex. example@gmail.com, demo@yahoo.com</div>
                                    </div>
                                </div>
                                <div class="wpie-scheduled-export-inner">
                                    <div class="wpie-scheduled-export-data-label"><?php esc_html_e('Enter Email Subject', 'woo-import-export'); ?></div>
                                    <div class="wpie-scheduled-export-data-element-wrapper">
                                        <input class="wpie-filter-input wpie-scheduled-export-email-subject" type="text" placeholder="<?php esc_attr_e('Enter Email Subject', 'woo-import-export'); ?>" name="wpie_scheduled_export_email_subject">
                                    </div>
                                </div>
                                <div class="wpie-scheduled-export-inner">
                                    <div class="wpie-scheduled-export-data-label"><?php esc_html_e('Enter Email message', 'woo-import-export'); ?></div>
                                    <div class="wpie-scheduled-export-data-element-wrapper">
                                        <textarea class="wpie-scheduled-export-email-content wpie-filter-input wpie-filter-input-textarea" name="wpie_scheduled_export_email_content" placeholder="<?php esc_attr_e('Enter Email message', 'woo-import-export'); ?>"></textarea>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="wpie-filter-input-hint-wrapper"></div>
                </div>
            </div>
            <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                <div class="wpie-filter-btn-wrapper">
                    <a class="wpie-general-btn wpie-order-export-preview" ><?php esc_html_e('Preview', 'woo-import-export'); ?></a>
                    <a class="wpie-general-btn wpie-order-export" ><?php esc_html_e('Export', 'woo-import-export'); ?></a>
                    <a class="wpie-general-btn wpie-order-scheduled-export-data wpie-scheduled-save-export-data wpie-hidden" ><?php esc_html_e('Save Scheduled', 'woo-import-export'); ?></a>
                </div>
            </div>
        </form>
        <div class="wpie-filter-data-container wpie-datatable-wrapper-sample">
            <table class="wpie-product-filter-data wpie-datatable table table-striped table-bordered" width="100%" cellspacing="0">
                <thead>
                    <tr>
                        <?php
                        if (!empty($order_fields)) {
                            foreach ($order_fields as $new_product_cat_fields) {
                                if (!empty($new_product_cat_fields)) {
                                    foreach ($new_product_cat_fields as $order_fields_data) {
                                        if (isset($order_fields_data['field_display']) && $order_fields_data['field_display'] == 1) {
                                            echo '<th>' . esc_html($order_fields_data['field_title']) . '</th>';
                                        }
                                    }
                                }
                            }
                        }
                        ?>
                    </tr>

                </thead>
            </table>
        </div>
        <div class="wpie-filter-data-container wpie-datatable-wrapper"></div>
    </div>
    <div class="container-fluid offset-10 wpie-import-wrapper wpie-main-frm-wrapper">
        <form method="post" class="wpie-order-import-frm wpie-general-frm">
            <input type="hidden" name="wpie_csv_upload_file" class="wpie_csv_upload_file_path" value=""> 
            <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                <div class="wpie-filter-inner-wrapper">
                    <div class="wpie-filter-input-wrapper">
                        <div class="wpie-csv-upload-wrapper">
                            <div id="wpie-upload-container" class="wpie-upload-container">
                                <div id="wpie-upload-drag-drop" class="wpie-upload-drag-drop">
                                    <div class="wpie-upload-file-label"><?php esc_html_e('Drop CSV file here', 'woo-import-export'); ?></div>
                                    <div class="wpie-upload-file-label-small"> <?php esc_html_e('OR', 'woo-import-export'); ?></div>
                                    <div class="wpie-upload-file-btn"><input id="plupload-browse-button" type="button" value="<?php esc_attr_e('Select Files', 'woo-import-export'); ?>" class="button" /></div>
                                </div>
                            </div>
                            <div class="wpie-uploaded-file-list"></div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
                <div class="wpie-filter-inner-wrapper">
                    <div class="wpie-filter-title-text-wrapper">
                        <div class="wpie-filter-title-text"><?php esc_html_e('Enter CSV File URL for Download and Import', 'woo-import-export'); ?></div>
                    </div>
                    <div class="wpie-filter-input-wrapper">
                        <input type="text" name="wpie_import_file_url" class="wpie-filter-input wpie_import_file_url" placeholder="<?php esc_attr_e('Enter CSV File URL', 'woo-import-export'); ?>"/>
                    </div>
                    <div class="wpie-filter-input-hint-wrapper">
                        <div class="wpie-filter-input-hint"><?php esc_html_e('Note : Leave blank if upload file.', 'woo-import-export'); ?></div>
                    </div>
                </div>
            </div>
            <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
                <div class="wpie-filter-inner-wrapper">
                    <div class="wpie-filter-title-text-wrapper">
                        <div class="wpie-filter-title-text"><?php esc_html_e('Order Create / Update / Skip', 'woo-import-export'); ?></div>
                    </div>
                    <div class="wpie-filter-input-wrapper">
                        <select class="wpie_export_field_select_element wpie-select-chosen" name="wpie_order_create_method"  data-placeholder="<?php esc_attr_e('Select order create option', 'woo-import-export'); ?>" >
                            <option value="skip_order"><?php esc_html_e('Skip Order if Exist.', 'woo-import-export'); ?></option>
                            <option value="create_order"><?php esc_html_e('Create New Order and ignore if Exist.', 'woo-import-export'); ?></option>
                            <option value="update_order"><?php esc_html_e('Update Order if Exist.', 'woo-import-export'); ?></option>
                        </select>
                    </div>
                    <div class="wpie-filter-input-hint-wrapper">
                        <div class="wpie-filter-input-hint"><?php esc_html_e('Note : Imported order is created, updated or skip if already exist.', 'woo-import-export'); ?></div>
                    </div>
                </div>
            </div>
            <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
                <div class="wpie-filter-inner-wrapper">
                    <div class="wpie-filter-title-text-wrapper">
                        <div class="wpie-filter-title-text"><?php esc_html_e('Order Search based on', 'woo-import-export'); ?></div>
                    </div>
                    <div class="wpie-filter-input-wrapper">
                        <select class="wpie-select-chosen" name="wpie_data_update_option"  data-placeholder="<?php esc_attr_e('Select Order Search Option', 'woo-import-export'); ?>" >
                            <option value="order_key"><?php esc_html_e('Order Key', 'woo-import-export'); ?></option>
                            <option value="order_id"><?php esc_html_e('Order ID', 'woo-import-export'); ?></option>
                        </select>
                    </div>
                    <div class="wpie-filter-input-hint-wrapper">
                        <div class="wpie-filter-input-hint"><?php esc_html_e('Default : Order Key', 'woo-import-export'); ?></div>
                    </div>
                </div>
            </div>
            <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
                <div class="wpie-filter-inner-wrapper">
                    <div class="wpie-filter-title-text-wrapper">
                        <div class="wpie-filter-title-text"><?php esc_html_e('CSV Field Separator', 'woo-import-export'); ?></div>
                    </div>
                    <div class="wpie-filter-input-wrapper">
                        <input type="text" name="wpie_import_determinator" class="wpie-filter-input wpie_import_determinator" placeholder="<?php esc_attr_e('Enter Field Separator', 'woo-import-export'); ?>" value=","/>
                    </div>
                    <div class="wpie-filter-input-hint-wrapper">
                        <div class="wpie-filter-input-hint"><?php esc_html_e('Default : comma ( , )', 'woo-import-export'); ?></div>
                    </div>
                </div>
            </div>
            <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
                <div class="wpie-filter-inner-wrapper">
                    <div class="wpie-filter-title-text-wrapper">
                        <div class="wpie-filter-title-text"><?php esc_html_e('Records Per iteration', 'woo-import-export'); ?></div>
                    </div>
                    <div class="wpie-filter-input-wrapper">
                        <input type="text" name="wpie_import_records_per_iteration" class="wpie-filter-input wpie_import_records_per_iteration" placeholder="<?php esc_attr_e('Enter Records Per iteration', 'woo-import-export'); ?>" value="20"/>
                    </div>
                    <div class="wpie-filter-input-hint-wrapper">
                        <div class="wpie-filter-input-hint"><?php esc_html_e('Default : 20 Records', 'woo-import-export'); ?></div>
                    </div>
                </div>
            </div>
            <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
                <div class="wpie-filter-inner-wrapper">
                    <div class="wpie-filter-title-text-wrapper">
                        <div class="wpie-filter-title-text"><?php esc_html_e('Email Notifications for Customers', 'woo-import-export'); ?></div>
                        <div class="wpie-filter-title-text-sub-title"></div>
                    </div>
                    <div class="wpie-filter-input-wrapper">
                        <input type="checkbox" id="wpie_order_block_email_notification" class="wpie-filter-input-check" checked="checked" value="1" name="wpie_order_block_email_notification" />
                        <label for="wpie_order_block_email_notification" class="wpie-product-scheduled-export-label"><?php esc_html_e('Block email notifications during import', 'woo-import-export'); ?></label>
                    </div>
                    <div class="wpie-filter-input-hint-wrapper">
                        <div class="wpie-filter-input-hint"><?php esc_html_e('Prevent WordPress from sending notification emails to customers when their orders are imported or updated.', 'woo-import-export'); ?></div>
                    </div>
                </div>
            </div>
            <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
                <div class="wpie-filter-inner-wrapper">
                    <div class="wpie-filter-title-text-wrapper">
                        <div class="wpie-filter-title-text"><?php esc_html_e('Scheduled Import', 'woo-import-export'); ?></div>
                        <div class="wpie-filter-title-text-sub-title"></div>
                    </div>
                    <div class="wpie-filter-input-wrapper">
                        <input type="checkbox" id="wpie-product-scheduled-import" class="wpie-filter-input-check wpie-scheduled-export-check-data" name="wpie_product_scheduled_export" placeholder="<?php esc_attr_e('Enter Offset Records', 'woo-import-export'); ?>"/>
                        <label for="wpie-product-scheduled-import" class="wpie-product-scheduled-export-label"><?php esc_html_e('Scheduled Import', 'woo-import-export'); ?></label>
                        <div class="wpie-scheduled-export-wrapper">
                            <div class="wpie-scheduled-export-outer-details">
                                <div class="wpie-scheduled-export-inner">
                                    <div class="wpie-scheduled-export-data-label"><?php esc_html_e('Import Interval', 'woo-import-export'); ?></div>
                                    <div class="wpie-scheduled-export-data-element-wrapper">
                                        <select class="wpie-export-field-select-element wpie-select-chosen" data-placeholder="<?php esc_attr_e('Select Interval', 'woo-import-export'); ?>" name="wpie_import_interval">
                                            <?php if (!empty($get_schedules_list)) { ?>
                                                <?php foreach ($get_schedules_list as $key => $value) { ?>
                                                    <option value="<?php echo esc_attr($key); ?>"><?php echo esc_html(isset($value['display']) ? $value['display'] : ""); ?></option>
                                                <?php } ?>
                                            <?php } ?>
                                        </select>
                                    </div>
                                </div>
                                <div class="wpie-scheduled-export-inner">
                                    <div class="wpie-scheduled-export-data-label"><?php esc_html_e('Import Interval Time', 'woo-import-export'); ?></div>
                                    <div class="wpie-scheduled-export-data-element-wrapper">
                                        <input class="wpie-filter-input wpie-scheduled-export-time" type="text" placeholder="<?php esc_attr_e('Enter Time for import', 'woo-import-export'); ?>" name="wpie_scheduled_import_time">
                                        <div class="wpie-filter-input-hint"><?php esc_html_e('Value : 00:00:01 to 23:59:59, Default : Current time', 'woo-import-export'); ?></div>
                                    </div>
                                </div>
                                <div class="wpie-scheduled-export-inner">
                                    <div class="wpie-scheduled-export-data-label"><?php esc_html_e('Send E-mail', 'woo-import-export'); ?></div>
                                    <div class="wpie-scheduled-export-data-element-wrapper">
                                        <input type="checkbox" class="wpie-filter-input-check wpie-scheduled-send-email" id="wpie-scheduled-import-send-email" name="wpie_product_scheduled_send_email" value="1"/>
                                        <label for="wpie-scheduled-import-send-email" class="wpie-product-scheduled-export-label"><?php esc_html_e('Send E-mail with attachment', 'woo-import-export'); ?></label>
                                    </div>
                                </div>
                            </div>
                            <div class="wpie-scheduled-export-email-details">
                                <div class="wpie-scheduled-export-inner">
                                    <div class="wpie-scheduled-export-data-label"><?php esc_html_e('Enter Email Recipient(s)', 'woo-import-export'); ?></div>
                                    <div class="wpie-scheduled-export-data-element-wrapper">
                                        <input class="wpie-filter-input wpie-scheduled-export-email-recipients" type="text" placeholder="<?php esc_attr_e('Enter Email Recipient(s)', 'woo-import-export'); ?>" name="wpie_scheduled_export_email_recipients">
                                        <div class="wpie-filter-input-hint">Ex. example@gmail.com, demo@yahoo.com</div>
                                    </div>
                                </div>
                                <div class="wpie-scheduled-export-inner">
                                    <div class="wpie-scheduled-export-data-label"><?php esc_html_e('Enter Email Subject', 'woo-import-export'); ?></div>
                                    <div class="wpie-scheduled-export-data-element-wrapper">
                                        <input class="wpie-filter-input wpie-scheduled-export-email-subject" type="text" placeholder="<?php esc_attr_e('Enter Email Subject', 'woo-import-export'); ?>" name="wpie_scheduled_export_email_subject">
                                    </div>
                                </div>
                                <div class="wpie-scheduled-export-inner">
                                    <div class="wpie-scheduled-export-data-label"><?php esc_html_e('Enter Email message', 'woo-import-export'); ?></div>
                                    <div class="wpie-scheduled-export-data-element-wrapper">
                                        <textarea class="wpie-scheduled-export-email-content wpie-filter-input wpie-filter-input-textarea" name="wpie_scheduled_export_email_content" placeholder="<?php esc_attr_e('Enter Email message', 'woo-import-export'); ?>"></textarea>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="wpie-filter-input-hint-wrapper"></div>
                </div>
            </div>
            <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                <div class="wpie-filter-btn-wrapper">
                    <a class="wpie-general-btn wpie-order-import" ><?php esc_html_e('Import', 'woo-import-export'); ?></a>
                    <a class="wpie-general-btn wpie-order-scheduled-import-data wpie-scheduled-save-export-data wpie-hidden" ><?php esc_html_e('Save Scheduled', 'woo-import-export'); ?></a>
                </div>
            </div>
        </form>
        <div class="wpie-filter-data-container wpie-datatable-import-wrapper"></div>
    </div>
    <div class="container-fluid offset-10 wpie-scheduled-wrapper wpie-main-frm-wrapper">
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="wpie-advanced-option-wrapper">
                <div class="wpie-schedueld-list-title wpie-advanced-option-header"><?php esc_html_e('Scheduled Export List', 'woo-import-export'); ?></div>
                <div class="wpie-schedueld-list-data wpie-advanced-option-data">
                    <table class="wpie-product-scheduled-export wpie-scheduled-list table table-striped table-bordered" width="100%" cellspacing="0">
                        <thead>
                            <tr>
                                <th><?php esc_html_e('Scheduled ID', 'woo-import-export'); ?></th>
                                <th><?php esc_html_e('Recurrence Time', 'woo-import-export'); ?></th>
                                <th><?php esc_html_e('Send E-mail', 'woo-import-export'); ?></th>
                                <th><?php esc_html_e('Recipients', 'woo-import-export'); ?></th>
                                <th><?php esc_html_e('Next event', 'woo-import-export'); ?></th>
                                <th><?php esc_html_e('Actions', 'woo-import-export'); ?></th>
                            </tr>
                        </thead>
                        <tbody>
                            <?php if (!empty($order_scheduled_export_list)) { ?>
                                <?php foreach ($order_scheduled_export_list as $key => $value) { ?>
                                    <tr>
                                        <td><?php echo esc_html($key); ?></td>
                                        <td><?php echo esc_html($get_schedules_list[$value['wpie_export_interval']]['display']); ?></td>
                                        <td><?php
                                            if (isset($value['wpie_product_scheduled_send_email']) && $value['wpie_product_scheduled_send_email'] == 1) {
                                                esc_html_e('Yes', 'woo-import-export');
                                            } else {
                                                esc_html_e('No', 'woo-import-export');
                                            }
                                            ?></td>
                                        <td><?php echo esc_html($value['wpie_scheduled_export_email_recipients']); ?></td>
                                        <td><?php echo esc_html(date_i18n(get_option('date_format') . ' ' . get_option('time_format'), wp_next_scheduled('wpie_cron_scheduled_order_export', array($key)))); ?></td>
                                        <td><div class="wpie-delete-cron-data wpie-delete-order-export-cron" cron_id="<?php echo esc_attr($key); ?>"><?php esc_html_e('DELETE', 'woo-import-export'); ?></div></td>
                                    </tr>
                                <?php } ?>
                            <?php } ?>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="wpie-advanced-option-wrapper">
                <div class="wpie-schedueld-list-title wpie-advanced-option-header"><?php esc_html_e('Scheduled Import List', 'woo-import-export'); ?></div>
                <div class="wpie-schedueld-list-data wpie-advanced-option-data">
                    <table class="wpie-product-scheduled-import wpie-scheduled-import-list table table-striped table-bordered" width="100%" cellspacing="0">
                        <thead>
                            <tr>
                                <th><?php esc_html_e('Scheduled ID', 'woo-import-export'); ?></th>
                                <th><?php esc_html_e('Recurrence Time', 'woo-import-export'); ?></th>
                                <th><?php esc_html_e('Send E-mail', 'woo-import-export'); ?></th>
                                <th><?php esc_html_e('Recipients', 'woo-import-export'); ?></th>
                                <th><?php esc_html_e('Next event', 'woo-import-export'); ?></th>
                                <th><?php esc_html_e('Actions', 'woo-import-export'); ?></th>
                            </tr>
                        </thead>
                        <tbody>
                            <?php if (!empty($order_scheduled_import_list)) { ?>
                                <?php foreach ($order_scheduled_import_list as $key => $value) { ?>
                                    <tr>
                                        <td><?php echo esc_html($key); ?></td>
                                        <td><?php echo esc_html($get_schedules_list[$value['wpie_import_interval']]['display']); ?></td>
                                        <td><?php
                                            if (isset($value['wpie_product_scheduled_send_email']) && $value['wpie_product_scheduled_send_email'] == 1) {
                                                esc_html_e('Yes', 'woo-import-export');
                                            } else {
                                                esc_html_e('No', 'woo-import-export');
                                            }
                                            ?></td>
                                        <td><?php echo esc_html($value['wpie_scheduled_export_email_recipients']); ?></td>
                                        <td><?php echo esc_html(date_i18n(get_option('date_format') . ' ' . get_option('time_format'), wp_next_scheduled('wpie_cron_scheduled_order_import', array($key)))); ?></td>
                                        <td><div class="wpie-delete-cron-data wpie-delete-order-import-cron" cron_id="<?php echo esc_attr($key); ?>"><?php esc_html_e('DELETE', 'woo-import-export'); ?></div></td>
                                    </tr>
                                <?php } ?>
                            <?php } ?>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
    <div class="container-fluid offset-10 wpie-advanced-wrapper wpie-main-frm-wrapper">
        <div class="wpie-advanced-option-wrapper"> 
            <div class="wpie-advanced-option-header"><?php esc_html_e('Manage Fields', 'woo-import-export'); ?></div> 
            <div class="wpie-advanced-option-data">
                <div class="wpie_toggle_fields"><?php esc_html_e('Check/Uncheck All', 'woo-import-export'); ?></div>
                <form class="wpie-order-fields-frm">
                    <?php
                    if (!empty($order_fields)) {
                        foreach ($order_fields as $new_product_cat_field) {
                            if (!empty($new_product_cat_field)) {
                                foreach ($new_product_cat_field as $key => $value) {
                                    ?>
                                    <div class="col-lg-3 col-md-4 col-sm-4 col-xs-12">
                                        <div class="wpie-fields-elements-status">
                                            <input id="<?php echo esc_attr('wpie-field-' . $value['field_key']); ?>" value="1" name="<?php echo esc_attr('wpie_' . $value['field_key'] . '_field_check'); ?>" type="checkbox" class="wpie_export_field wpie-fields-elements-status-check" <?php checked($value['field_display'], 1); ?> >
                                        </div>
                                        <div class="wpie-fields-elements-label-wrapper"><label for="<?php echo esc_attr('wpie-field-' . $value['field_key']); ?>" class="wpie-fields-elements-label"><?php echo esc_html($value['field_title']); ?></label></div>
                                    </div>
                                    <?php
                                }
                            }
                        }
                    }
                    ?>
                    <div class="wpie-advanced-option-data-container">
                        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                            <a class="wpie-general-btn wpie-order-settings-btn" ><?php esc_html_e('Save', 'woo-import-export'); ?></a>
                        </div>
                    </div>
                </form>
            </div>
        </div>
        <div class="wpie-advanced-option-wrapper"> 
            <div class="wpie-advanced-option-header"><?php esc_html_e('Import Log', 'woo-import-export'); ?></div> 
            <div class="wpie-advanced-option-data">
                <table class="wpie-product-import-log wpie-datatable-view wpie-datatable table table-striped table-bordered" cellspacing="0">
                    <thead>
                        <tr>
                            <th><?php esc_html_e('No', 'woo-import-export'); ?></th>
                            <th><?php esc_html_e('File Name', 'woo-import-export'); ?></th>
                            <th><?php esc_html_e('Date', 'woo-import-export'); ?></th>
                            <th><?php esc_html_e('Action', 'woo-import-export'); ?></th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php if (!empty($import_log_list)) { ?>
                            <?php $temp_count = 1; ?>
                            <?php foreach ($import_log_list as $import_log_data) { ?>
                                <tr>
                                    <td><?php echo esc_html($temp_count++); ?></td>
                                    <td class="wpie_filename_list"><?php echo esc_html(substr($import_log_data->export_log_file_name, 11)); ?></td>
                                    <td><?php echo esc_html($import_log_data->create_date); ?></td>
                                    <td>
                                        <div class="wpie-log-action-wrapper">
                                            <div class="wpie-log-download-action " log_id="<?php echo esc_attr($import_log_data->export_log_id); ?>"><?php esc_html_e('Download', 'woo-import-export'); ?></div>
                                            <div class="wpie-log-delete-action wpie-import-log-delete-action" log_id="<?php echo esc_attr($import_log_data->export_log_id); ?>" ><?php esc_html_e('Delete', 'woo-import-export'); ?></div>
                                        </div>
                                    </td>
                                </tr>
                            <?php } ?>
                        <?php }
                        ?>
                    </tbody>
                    <tfoot>
                        <tr>
                            <th><?php esc_html_e('No', 'woo-import-export'); ?></th>
                            <th><?php esc_html_e('File Name', 'woo-import-export'); ?></th>
                            <th><?php esc_html_e('Date', 'woo-import-export'); ?></th>
                            <th><?php esc_html_e('Action', 'woo-import-export'); ?></th>
                        </tr>
                    </tfoot>
                </table>
            </div>
        </div>
        <div class="wpie-advanced-option-wrapper"> 
            <div class="wpie-advanced-option-header"><?php esc_html_e('Export Log', 'woo-import-export'); ?></div> 
            <div class="wpie-advanced-option-data">
                <table class="wpie-product-export-log wpie-datatable-view wpie-datatable table table-striped table-bordered" cellspacing="0">
                    <thead>
                        <tr>
                            <th><?php esc_html_e('No.', 'woo-import-export'); ?></th>
                            <th><?php esc_html_e('File Name', 'woo-import-export'); ?></th>
                            <th><?php esc_html_e('Date', 'woo-import-export'); ?></th>
                            <th><?php esc_html_e('Action', 'woo-import-export'); ?></th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php if (!empty($log_list)) { ?>
                            <?php $temp_count = 1; ?>
                            <?php foreach ($log_list as $log_data) { ?>
                                <tr>
                                    <td><?php echo esc_html($temp_count++); ?></td>
                                    <td class="wpie_filename_list"><?php echo esc_html($log_data->export_log_file_name); ?></td>
                                    <td><?php echo esc_html($log_data->create_date); ?></td>
                                    <td>
                                        <div class="wpie-log-action-wrapper">
                                            <div class="wpie-log-download-action" log_id="<?php echo esc_attr($log_data->export_log_id); ?>" ><?php esc_html_e('Download', 'woo-import-export'); ?></div>
                                            <div class="wpie-log-delete-action wpie-export-log-delete-action" log_id="<?php echo esc_attr($log_data->export_log_id); ?>" ><?php esc_html_e('Delete', 'woo-import-export'); ?></div>
                                        </div>
                                    </td>
                                </tr>
                            <?php } ?>
                        <?php }
                        ?>
                    </tbody>
                    <tfoot>
                        <tr>
                            <th><?php esc_html_e('No.', 'woo-import-export'); ?></th>
                            <th><?php esc_html_e('File Name', 'woo-import-export'); ?></th>
                            <th><?php esc_html_e('Date', 'woo-import-export'); ?></th>
                            <th><?php esc_html_e('Action', 'woo-import-export'); ?></th>
                        </tr>
                    </tfoot>
                </table>
            </div>
        </div>
    </div>
</div>
<form class="wpie-download-exported-file-frm" method="post">
    <input type="hidden" class="wpie_download_exported_file" name="wpie_download_exported_file" >
</form>
<div class="wpie-documantation-links-wrapper">
    <div class="wpie-documantation-links-outer">
        <a class="wpie-documantation-links" target="_blank" href="<?php echo esc_url("http://www.vjinfotech.com/products/woo-imp-exp/documentation/"); ?>"><?php esc_html_e('Documentation', 'woo-import-export'); ?></a> |  <a class="wpie-documantation-links" target="_blank" href="<?php echo esc_url("http://www.vjinfotech.com/support"); ?>"><?php esc_html_e('Support', 'woo-import-export'); ?></a>
    </div>
</div>
<?php
unset($order_status, $product_category_list, $get_schedules_list, $product_list, $order_ids, $order_fields, $order_scheduled_export_list, $order_scheduled_import_list, $log_list, $import_log_list, $total_orders);
