<?php

/**
 * Fired when the plugin is uninstalled.
 *
 * When populating this file, consider the following flow
 * of control:
 *
 * - This method should be static
 * - Check if the $_REQUEST content actually is the plugin name
 * - Run an admin referrer check to make sure it goes through authentication
 * - Verify the output of $_GET makes sense
 * - Repeat with other user roles. Best directly by using the links/query string parameters.
 * - Repeat things for multisite. Once for a single site in the network, once sitewide.
 *
 * This file may be updated more in future version of the Boilerplate; however, this is the
 * general skeleton and outline for how the file should work.
 *
 * @link    https://codecanyon.net/item/woo-import-export/13694764
 * @since   2.5.4
 * @package Woo Import Export
 */
// If uninstall not called from WordPress, then exit.
if (!defined('WP_UNINSTALL_PLUGIN')) {
    exit;
}

global $wpdb;

//remove schedule export
wp_clear_scheduled_hook("wpie_cron_scheduled_order_export");
wp_clear_scheduled_hook("wpie_cron_scheduled_product_export");
wp_clear_scheduled_hook("wpie_cron_scheduled_user_export");
wp_clear_scheduled_hook("wpie_cron_scheduled_product_cat_export");
wp_clear_scheduled_hook("wpie_cron_scheduled_coupon_export");

//remove schedule Import
wp_clear_scheduled_hook("wpie_cron_scheduled_coupon_import");
wp_clear_scheduled_hook("wpie_cron_scheduled_product_import");
wp_clear_scheduled_hook("wpie_cron_scheduled_product_cat_import");
wp_clear_scheduled_hook("wpie_cron_scheduled_order_import");
wp_clear_scheduled_hook("wpie_cron_scheduled_user_import");

//remove options
$wpdb->query("DELETE FROM {$wpdb->options} WHERE option_name LIKE 'wpie_%'");

//remove tables
$wpdb->query("DROP TABLE IF EXISTS " . $wpdb->prefix . "wpie_export_log");


