<?php

/*
  Plugin Name: Woo Import Export
  Description: Advanced WooCommerce Store Products, Orders, Users, Product Categories, Coupons data Import Export with Multiple Filter, Export Management, Field Management, Scheduled Management.
  Version: 2.5.5
  Author: پرشین اسکریپت
  Author URI: http://www.persianscript.ir
  Text Domain: woo-import-export
  Domain Path: /languages/
  WC tested up to: 3.7.0
 */

if (!defined('ABSPATH')) {
    die(__("Can't load this file directly", "woo-import-export"));
}

global $wpdb, $wpie_get_record_count, $wpie_fatch_import_records;

$wpie_get_record_count = 50;

$wpie_fatch_import_records = 30;

// Plugin version
if (!defined('WPIE_PLUGIN_VERSION')) {
    define('WPIE_PLUGIN_VERSION', '2.5.5');
}
// Plugin base name
if (!defined('WPIE_PLUGIN_FILE')) {
    define('WPIE_PLUGIN_FILE', __FILE__);
}

// Plugin Folder Path
if (!defined('WPIE_PLUGIN_DIR')) {
    define('WPIE_PLUGIN_DIR', realpath(plugin_dir_path(WPIE_PLUGIN_FILE)) . '/');
}

$plugin_url = plugin_dir_url(WPIE_PLUGIN_FILE);

if (is_ssl()) {
    $plugin_url = str_replace('http://', 'https://', $plugin_url);
}
if (!defined('WPIE_PLUGIN_URL')) {
    define('WPIE_PLUGIN_URL', $plugin_url);
}

if (!defined('WPIE_ASSETS_URL')) {
    define('WPIE_ASSETS_URL', WPIE_PLUGIN_URL . '/assets');
}
if (!defined('WPIE_CSS_URL')) {
    define('WPIE_CSS_URL', WPIE_ASSETS_URL . '/css');
}
if (!defined('WPIE_JS_URL')) {
    define('WPIE_JS_URL', WPIE_ASSETS_URL . '/js');
}
if (!defined('WPIE_IMAGES_URL')) {
    define('WPIE_IMAGES_URL', WPIE_ASSETS_URL . '/images');
}
if (!defined('WPIE_INCLUDES_DIR')) {
    define('WPIE_INCLUDES_DIR', WPIE_PLUGIN_DIR . '/includes');
}
if (!defined('WPIE_CLASSES_DIR')) {
    define('WPIE_CLASSES_DIR', WPIE_INCLUDES_DIR . '/classes');
}
if (!defined('WPIE_VIEW_DIR')) {
    define('WPIE_VIEW_DIR', WPIE_INCLUDES_DIR . '/views');
}
// Plugin site path
if (!defined('WPIE_PLUGIN_SITE')) {
    define('WPIE_PLUGIN_SITE', 'http://www.vjinfotech.com');
}

$wpupload_dir = wp_upload_dir();

$wpie_upload_dir = $wpupload_dir['basedir'] . '/woo-import-export';

$wpie_upload_url = $wpupload_dir['baseurl'] . '/woo-import-export';

define('WPIE_UPLOAD_DIR', $wpie_upload_dir);

define('WPIE_UPLOAD_URL', $wpie_upload_url);

wp_mkdir_p($wpie_upload_dir);

if (@is_writable(WPIE_UPLOAD_DIR) && @is_dir(WPIE_UPLOAD_DIR)) {
    @touch(WPIE_UPLOAD_DIR . '/index.php');
}

global $wpie_init, $wpie_product, $wpie_user, $wpie_order, $wpie_coupon, $wpie_product_category, $wpie_scheduled, $wpie_auto_update;

if (file_exists(WPIE_CLASSES_DIR . '/class-wpie-init.php')) {
    require_once( WPIE_CLASSES_DIR . '/class-wpie-init.php' );

    $wpie_init = new WPIE_INIT();
}

if (file_exists(WPIE_CLASSES_DIR . '/class-wpie-product.php')) {
    require_once( WPIE_CLASSES_DIR . '/class-wpie-product.php' );

    $wpie_product = new WPIE_PRODUCT();
}

if (file_exists(WPIE_CLASSES_DIR . '/class-wpie-product-category.php')) {
    require_once( WPIE_CLASSES_DIR . '/class-wpie-product-category.php' );

    $wpie_product_category = new WPIE_PRODUCT_CATEGORY();
}

if (file_exists(WPIE_CLASSES_DIR . '/class-wpie-user.php')) {
    require_once( WPIE_CLASSES_DIR . '/class-wpie-user.php' );

    $wpie_user = new WPIE_USER();
}

if (file_exists(WPIE_CLASSES_DIR . '/class-wpie-order.php')) {
    require_once( WPIE_CLASSES_DIR . '/class-wpie-order.php' );

    $wpie_order = new WPIE_ORDER();
}

if (file_exists(WPIE_CLASSES_DIR . '/class-wpie-coupon.php')) {
    require_once( WPIE_CLASSES_DIR . '/class-wpie-coupon.php' );

    $wpie_coupon = new WPIE_COUPON();
}

if (file_exists(WPIE_CLASSES_DIR . '/class-wpie-scheduled.php')) {
    require_once( WPIE_CLASSES_DIR . '/class-wpie-scheduled.php' );

    $wpie_scheduled = new WPIE_SCHEDULED();
}

if (file_exists(WPIE_CLASSES_DIR . '/class-wpie-auto-update.php')) {
    require_once( WPIE_CLASSES_DIR . '/class-wpie-auto-update.php' );

    $wpie_auto_update = new WPIE_AUTO_UPDATE();
}